using System;
using System.Collections.Generic;
using System.Text;
using System.Diagnostics;

namespace Array9
{
  class Program
  {
    static void Main(string[] args)
    {
      Stopwatch sw = new Stopwatch();
      Random rand = new Random((int)DateTime.Now.Ticks);

      double[] dArray = new double[100000];

      for (int i = 0; i < 100000; i++)
      {
        dArray[i] = rand.NextDouble();
      }

      Console.WriteLine(dArray[0]);
      Console.WriteLine(dArray[1]);
      Console.WriteLine(dArray[2]);

      dArray[99999] = 2.0;

      // Methode 1:
      sw.Start();
      int iInd = -1;

      for (int i = 0; i < 100000; i++)
      {
        if (dArray[i] == 2.0)
        {
          iInd = i;
          sw.Stop();
          Console.WriteLine("Methode 1: Index = {0}, Zeit = {1}", iInd, sw.ElapsedTicks);
          sw.Reset();
          break;
        }
      }

      // Methode 2:
      sw.Start();
      iInd = -1;

      iInd = Array.IndexOf(dArray, 2.0);

      sw.Stop();
      Console.WriteLine("Methode 2: Index = {0}, Zeit = {1}", iInd, sw.ElapsedTicks);
      sw.Reset();

      // Methode 3:
      sw.Start();
      iInd = -1;

      iInd = Array.IndexOf<double>(dArray, 2.0);

      sw.Stop();
      Console.WriteLine("Methode 3: Index = {0}, Zeit = {1}", iInd, sw.ElapsedTicks);
      sw.Reset();

      // Methode 4:
      sw.Start();
      iInd = -1;

      iInd = Array.BinarySearch(dArray, 2.0);

      sw.Stop();
      Console.WriteLine("Methode 4 Aufruf 1: Index = {0}, Zeit = {1}", iInd, sw.ElapsedTicks);
      sw.Reset();

      sw.Start();
      iInd = -1;

      iInd = Array.BinarySearch(dArray, 2.0);

      sw.Stop();
      Console.WriteLine("Methode 4 Aufruf 2: Index = {0}, Zeit = {1}", iInd, sw.ElapsedTicks);
      sw.Reset();

      // Methode 4:
      sw.Start();
      iInd = -1;

      iInd = Array.BinarySearch<double>(dArray, 2.0);

      sw.Stop();
      Console.WriteLine("Methode 5 Aufruf 1: Index = {0}, Zeit = {1}", iInd, sw.ElapsedTicks);
      sw.Reset();

      sw.Start();
      iInd = -1;

      iInd = Array.BinarySearch<double>(dArray, 2.0);

      sw.Stop();
      Console.WriteLine("Methode 5 Aufruf 2: Index = {0}, Zeit = {1}", iInd, sw.ElapsedTicks);
      sw.Reset();
    }
  }
}
